require File.join(File.dirname(__FILE__), '../..', "tomte_protocol_spec_helper")

describe "A generic Consumer" do

  #
  # Environment
  #

  include EventedSpec::AMQPSpec
  default_options AMQP_OPTS
  default_timeout 5

  amqp_before do
    @ep  = Tomte::Protocol::Endpoint.new(:bus => :test)

  end

  def close_and_done
    @consumer.close {  @ep.disconnect! { done }}
  end

  it 'should handle reserved names' do

    @consumer = @ep.consumer(:queue => "amq.reserved ", :queue_options => {:auto_delete => true})
    @consumer.connect!(:errback => proc { close_and_done })

  end
end
