require File.join(File.dirname(__FILE__), '../..', "tomte_protocol_spec_helper")

describe "An Entity" do

  #
  # Environment
  #

  include EventedSpec::AMQPSpec
  default_options AMQP_OPTS
  default_timeout 5


  describe "when it is connected" do

    amqp_before do
      @ep  = Tomte::Protocol::Endpoint.new(:bus => :test)

      @producer = @ep.producer(:exchange => "tomte.tests.integration.direct.exchange",
                               :exchange_options => {:auto_delete => true})

    end

    def close_and_done
      @producer.close { @ep.disconnect! { done }}
    end


    it "should connect the endpoint, if it's not already connected"  do

      expect(@ep).not_to be_connected

      @producer.connect! do |p|
        expect(@ep).to be_connected
        close_and_done
      end
    end

    it "should NOT try to connect it if it is connected" do

      expect(@ep).not_to be_connected

      @ep.connect! do
        expect(@ep).to be_connected

        @producer.connect! do |p|
          expect(@ep).to be_connected
          close_and_done
        end
      end
    end
  end
end