require File.join(File.dirname(__FILE__), '../..', "tomte_protocol_spec_helper")

describe "A 'Hello, world'-like example with a non-empty message" do

  #
  # Environment
  #

  include EventedSpec::AMQPSpec
  default_options AMQP_OPTS
  default_timeout 5

  amqp_before do
    @ep  = Tomte::Protocol::Endpoint.new(:bus => :test)

    @producer = @ep.producer(:exchange => "tomte.tests.integration.direct.exchange",
                             :exchange_options => {:auto_delete => true})

    @consumer = @ep.consumer(:queue_options => {:auto_delete => true})
  end

  def close_and_done
    @producer.close { @consumer.close {  @ep.disconnect! { done }}}
  end

  amqp_after do

  end

  it "is delivered" do

    @consumer.on_delivery do |metadata, payload|

      close_and_done
    end

    @ep.connect! do
      @producer.connect! do |p|
        @consumer.connect! do |c|
          c.bind("tomte.tests.integration.direct.exchange",
                  :routing_key => "messages.all")

          c.consume
        end

        EventMachine.add_timer(0.5) do
          p.publish("Hello!", :routing_key => "messages.all")
        end
      end
    end


  end
end



describe "A 'Hello, world'-like example with a blank message" do

  #
  # Environment
  #

  include EventedSpec::AMQPSpec
  default_options AMQP_OPTS
  default_timeout 5

  amqp_before do
    @ep  = Tomte::Protocol::Endpoint.new(:bus => :test)

    @producer = @ep.producer(:exchange => "tomte.tests.integration.direct.exchange",
                             :exchange_options => {:auto_delete => true})

    @consumer = @ep.consumer(:queue_options => {:auto_delete => true})
  end

  def close_and_done
    @producer.close { @consumer.close {  @ep.disconnect! { done }}}
  end

  it "is delivered" do

    @consumer.on_delivery do |metadata, payload|
      close_and_done
    end

    @ep.connect! do
      @producer.connect! do |p|
        @consumer.connect! do |c|
          c.bind("tomte.tests.integration.direct.exchange",
                  :routing_key => "messages.all")

          c.consume
        end

        EventMachine.add_timer(0.5) do
          p.publish("", :routing_key => "messages.all")
        end
      end
    end
  end
end