require File.join(File.dirname(__FILE__), '../..', "tomte_protocol_spec_helper")


describe "A Synchronized endpoint" do

  describe "from the event thread" do
    include EventedSpec::AMQPSpec
    default_options AMQP_OPTS
    default_timeout 5

    amqp_before do
      @ep = Tomte::Protocol::Endpoint.new(:sync => true, :bus => :test)
    end

    it 'should detect deadlock' do
      EM.next_tick do
        expect { @ep.connect! }.to raise_error Tomte::Protocol::Synchronization::LockCondition
        delay(2) { done }
      end
    end
  end
end