require File.join(File.dirname(__FILE__), '../../..', "tomte_protocol_spec_helper")


describe "A Synchronized" do
  describe "RPC" do

    def endpoint
      @ep ||= Tomte::Protocol::Endpoint.new(:sync => true, :bus => :test).connect!
    end

    before :each do

    end

    after :each do
      endpoint.disconnect!
    end


    it 'should transport en exception, and raise it on return' do

      server = endpoint.rpc_server(:api => 'tomte.tests.integration.rpc').connect!
      server.server do |verb, request|
        expect(verb).to eq :ping

        raise ArgumentError, "hello"
      end
      server.consume

      client = endpoint.rpc_client(:api => 'tomte.tests.integration.rpc').connect!
      proxy = client.proxy

      expect { res = proxy.ping }.to raise_error Tomte::Protocol::RemoteException

      server.close
      client.close
    end

  end
end